/*
	ģȽԳ 
	main.c
	MCU:ATMega8
	
	о 2004-09-16
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#define uchar unsigned char

#define SET_RED_LED PORTB&=0XFD //PB1Ӻɫ
#define CLR_RED_LED PORTB|=0X02

#define SET_YEL_LED PORTB&=0XFE	//PB0ӻɫ
#define CLR_YEL_LED PORTB|=0X01

//ģȽжϺ
SIGNAL(SIG_COMPARATOR)
{
	if(ACSR & _BV(ACO))
	{
		SET_YEL_LED;
		CLR_RED_LED;
	}
	else
	{
		CLR_YEL_LED;
		SET_RED_LED;
	}
}

int main(void)
{
	DDRB=0X03;
	PORTB=0X03;

	//ģȽ¾ж ACIS1=ACIS0=0
	//ж ACIE=1
	ACSR=_BV(ACIE);

	sei();
	
	//AIN0: AIN1:  AIN0ϵĵѹAIN1ϵѹʱAC0=1
	if(ACSR & _BV(ACO))
	{
		SET_YEL_LED;
		CLR_RED_LED;
	}
	else
	{
		CLR_YEL_LED;
		SET_RED_LED;
	}

	while(1);
}