/*
	жϷʽԼ̳
	ļmain.c
	Ӳ:CA-M8
	ʱ:4MHz
	
	о 2004-12-17
*/

#include <avr/io.h>
#include <avr/delay.h>
#include <avr/signal.h>
#include <avr/interrupt.h>

#define uchar unsigned char
#define uint  unsigned int

#define FREQ   4

#define SER_PORT	PORTD
#define SER_DAT	PD4
#define SER_RCK	PD5
#define SER_SCK	PD6

#define KEY0	PD2
#define KEY1	PD3

//ʾ
uchar g_aDisplayBuf[16]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};
uchar g_bCounter=0;

void DelayMs(uint t)
{
	uint i;
	for(i=0;i<t;i++)
		_delay_loop_2(250 * FREQ);
}

//595 дһֽ
void ser_out(uchar dat)
{
	uchar i;

	for(i=0;i<8;i++)
	{
		if(dat&0x80)
			SER_PORT|=_BV(SER_DAT);
		else
			SER_PORT&=~_BV(SER_DAT);
		
		SER_PORT|=_BV(SER_SCK);
		SER_PORT&=~_BV(SER_SCK);
		dat<<=1;
	}
}
//ʾ(0~255)
//num :ʾ   hexǷʮʾ
void display_number(uchar num,uchar hex)
{
	uchar buf[2];//ʾ뻺
	uchar temp;
	
	if(hex) //ʮ
	{
		buf[0]=g_aDisplayBuf[num>>4];//λ
		buf[1]=g_aDisplayBuf[num&0x0f];//λ
	}
	else//ʮ
	{
		buf[1]=g_aDisplayBuf[num%10];
		temp=num%100;
		buf[0]=g_aDisplayBuf[temp/10];
		temp=num/100;
		
		if(temp>0)
			buf[1]|=0x80; //һСʾλ1
		if(temp>1)
			buf[0]|=0x80;//Сʾλ2
	}
	
	//з
	ser_out(buf[0]);
	ser_out(buf[1]);

	//ʾ
	SER_PORT|=_BV(SER_RCK);
	SER_PORT&=~_BV(SER_RCK);
}

//ⲿж0
SIGNAL(SIG_INTERRUPT0)
{
	DelayMs(100);
	display_number(++g_bCounter,0);
	GIFR|=_BV(INTF0);//д1жϱ־,
}

int main(void)
{
	DDRD=_BV(SER_DAT)|_BV(SER_SCK)|_BV(SER_RCK);
	PORTD=_BV(KEY0)|_BV(KEY1);//迪
	
	MCUCR=_BV(ISC00)|_BV(ISC01);//ش
	GICR=_BV(INT0);//ⲿж0
	sei();			//ж
	
	display_number(g_bCounter,0);
	while(1);
}
