/*
	жϷʽUARTԳ 
	main.c
	Ӳ:CA-M8
	ʱ:ⲿ4MHz
	
	о 2004-12-01
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#define uchar unsigned char
#define uint unsigned int

uchar g_bTxdPos=0;	//Ͷλ
uchar g_bTxdLen=0;	//ȴֽ
uchar g_bRxdPos=0;	//նλ
uchar g_bRxdLen=0;	//ȴֽ

uchar g_aSendBuf[16];	//緳
uchar g_aRecvBuf[16];	//ݻ

//ж
SIGNAL(SIG_UART_RECV)
{
	uchar c=UDR; 
	if(g_bRxdLen>0)
	{
		g_aRecvBuf[g_bRxdPos++]=c;
		g_bRxdLen--;
	}
}

//ж
SIGNAL (SIG_UART_TRANS)
{
	if(--g_bTxdLen>0)
		UDR=g_aSendBuf[++g_bTxdPos];
}

//Ƿ
uchar IsRecvComplete(void)
{
	return g_bRxdLen==0;
}

//ӷͻָ
void SendToUart(uchar size)
{
	g_bTxdPos=0;
	g_bTxdLen=size;
	UDR=g_aSendBuf[0];
	while(g_bTxdLen>0);
}

//ָݵջ
void RecvFromUart(uchar size,uchar bwait)
{
	g_bRxdPos=0;
	g_bRxdLen=size;
	if(bwait)
		while(g_bRxdLen>0);
}

int  main( void )
{
	uchar i;

    //uartʼ
	//ʹܡʹܡжж
 	UCSRB=(1<<RXCIE)|(1<<TXCIE)|(1<<RXEN)|(1<<TXEN);	
	UBRRL=25;	// baud=9600   UBRR=CK/(baud*16) -1   

	sei();//ж
	
	while(1)
	{
		//첽16ֽ
		RecvFromUart(16,0);

		//ȴ
		while(!IsRecvComplete());
		
		//յݸƵͻ
		for(i=0;i<16;i++)
			g_aSendBuf[i]=g_aRecvBuf[i];
		
		//ͻؽյ
		SendToUart(16);
	}
}