/*
	ļusart.c
	  ܣuartͨŽӿ
	C P U :	ATMega8
	  : WinAVR-20040404
	  ȣⲿ4MHz
	
	ļ¼
	2004-06-22       
*/

#include <avr/io.h>
#include <avr/interrupt.h> 
#include <avr/signal.h>

#include "usart.h"
#include "lp2004.h"

static uchar g_bTxdPos,g_bRxdPos,g_bTxdLen,g_bRxdLen;
//UART,ݰ/ջ
static uchar g_aUartBuf[LP_PACKET_SIZE];

void DelayMs(uint t);

//һֽж
SIGNAL(SIG_UART_RECV)
{
	uchar c=UDR; 
	if(g_bRxdLen>0)
	{
		g_aUartBuf[g_bRxdPos++]=c;
		g_bRxdLen--;
	}
}

//һֽж
SIGNAL (SIG_UART_TRANS)
{
	if(--g_bTxdLen>0)
		UDR=g_aUartBuf[++g_bTxdPos];
	else
		g_bTxdPos=0;
}

//UARTָȵ
void UartSend(uchar len)
{
	g_bTxdPos=0;
	g_bTxdLen=len;
	UDR=g_aUartBuf[0];
	while(g_bTxdLen>0)
		DelayMs(1);
}

//ָݵUART
void UartRecv(uchar len,uchar waitflag)
{
	g_bRxdPos=0;
	g_bRxdLen=len;
	
	if(waitflag)
	{ 
		while(g_bRxdLen>0)
			DelayMs(1);
	}
}

//첽Ƿ
uchar UartIsRecvComplate(void)
{
	return !g_bRxdLen;
}

//ȡUARTݻ
uchar *UartGetBuffer(void)
{
	return g_aUartBuf;
}

//ʼͨ첽ͨģ
void UartInit(void)
{
	uchar i;
	
	for(i=0;i<LP_PACKET_SIZE;i++)
		g_aUartBuf[i]=0;
	g_bTxdPos=0;
	g_bRxdPos=0;
	g_bTxdLen=0;
	g_bRxdLen=0;
	
	UCSRB=_BV(RXCIE)|_BV(TXCIE)|_BV(RXEN)|_BV(TXEN);
	UBRRH=0;
	UBRRL=25;//9600 baud 6MHz:38  4MHz:25
}
