/*
	avr-libc EEPROM дԳ <2313 - 1>
	main.c
	MCU:at90s2313
	
	о 2004-09-11
*/

#include <avr/io.h>
#include <avr/eeprom.h>

#define SET_LED PORTD=0X10;//PD4LED

int main(void)
{
	DDRD=0X10;
	PORTD=0X00;
	
	eeprom_busy_wait();
	eeprom_write_byte(0,0xaa);
	eeprom_busy_wait();
	eeprom_write_block("hello,this is test eeprom",(void *)1,sizeof("hello,this is test eeprom"));
	
	eeprom_busy_wait();
	if(eeprom_read_byte(0)==0xaa)
		SET_LED;
		
	while(1);
	return 0;
}
