/*
	ļslave.c 
	Mega8TWIͨʵģʽƬ
	
	ⲿ4MHz
	
	о 2004-09-02 --- 2004-09-03
*/

#include <avr/io.h>
#include <avr/twi.h>
#include <stdio.h>

#define uint unsigned int
#define uchar unsigned char

#define TWI_ADDRESS 0X32

//׼I/O
int usart_putchar(char c)
{
	if(c=='\n')
		usart_putchar('\r');
	loop_until_bit_is_set(UCSRA,UDRE);
	UDR=c;
	return 0;
}

//ʼ
void IoInit(void)
{
	//ʹSCLSDAڲ
	DDRC=0;
	PORTC=0X30;

	//пڳʼ
	UCSRB=_BV(RXEN)|_BV(TXEN);/*(1<<RXCIE)|(1<<TXCIE)|*/
	UBRRL=25;	//9600 baud 6MHz:38  4MHz:25	
	
	//UARTڱ׼I/O
	fdevopen(usart_putchar,0,0);	
	
	//TWIӿڳʼ,ģʽ
	TWAR=TWI_ADDRESS | _BV(TWGCE);
	TWCR=_BV(TWEA) | _BV(TWEN);
}

int main(void)
{
	uchar i,j=0;
	
	IoInit();
	
	while(1)
	{
		while ((TWCR & _BV(TWINT)) == 0);
		i=TW_STATUS;
		
		switch(i)
		{
			case TW_SR_SLA_ACK:
				printf("START\nSLA+W\n");
				break;
			case TW_SR_DATA_ACK:
				if(j==0)
					printf("յ:%d",TWDR);
				else
					printf(" %d",TWDR);
				j++;
				break;
			case TW_SR_STOP:
				printf(";\nSTOP\n\n");
				j=0;
				break;
			default:
				printf("error:%x",(int)i);
				break;
		}
		TWCR=_BV(TWEA) | _BV(TWEN)|_BV(TWINT);	//TWINTλ
	}

}
