// THThread.cpp: implementation of the CTHThread class.
//	о (c) copyright 2004
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TH.h"
#include "THThread.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTHThread::CTHThread()
{
}

CTHThread::~CTHThread()
{
}

//߳
DWORD CTHThread::ThreadSubProc()
{
	CString str;
	UCHAR c[3];
	UINT Y;
	HANDLE hEvent=OpenEvent(EVENT_ALL_ACCESS,FALSE,"M8BL_EVENT");
	ASSERT(hEvent);

	if(!m_Port.Open(2))
	{
		AfxMessageBox("˿2޷!",0);
		return 1;
	}

	while(1)
	{
		WaitForSingleObject(hEvent,INFINITE);
		switch(m_Command)
		{
		case M8BL_SETPAGE://ҳַ
			break;
		case M8BL_WRITE://дFLASH
			WriteFlash();
			break;
		case M8BL_READ://ȡFLASH
			Y=ReadFlash();
			break;
		case M8BL_RUN://
			c[0]=M8BL_RUN;
			m_Port.Write(c,1);
			break;
		default:
			break;
		}
		ResetEvent(hEvent);
		m_Port.GetError(str);
		if(str.IsEmpty())
			m_pParentWnd->SendMessage(MSG_REPORT,m_Command,Y);
	}
	m_Port.Close();
	return 0;
}

//дFLASH
void CTHThread::WriteFlash()
{
	int i,size;
	UCHAR c;
	UCHAR *codebuf;

	CProgressCtrl *pProgCtrl=(CProgressCtrl *)(m_pParentWnd->GetDlgItem(IDC_PROG));

	m_Port.ClearBuffer();//ڻ
	if(!ScanM8BL())
	{
		AfxMessageBox("δ");
		return ;
	}

	//Ҫдҳ
	size=m_CodeSize/M8BL_PAGESIZE;
	if((m_CodeSize%M8BL_PAGESIZE)>0)
		size++;
	size*=M8BL_PAGESIZE;
	
	//㹻ڴ
	
	codebuf=new UCHAR[size];
	if(codebuf==NULL)
	{
		AfxMessageBox("ڴ治");
		return ;
	}
	memset(codebuf,0xff,size);
	memcpy(codebuf,m_pBuffer,m_CodeSize);

	//λҳַΪ0
	c=M8BL_SETPAGE;
	m_Port.Write(&c,1);
	c=0;
	m_Port.Write(&c,1);
	m_Port.Read(&c,1,10000);

	//ѭд
	for(i=0;i<size;i+=M8BL_PAGESIZE)
	{
		c=M8BL_WRITE;
		m_Port.Write(&c,1);
		m_Port.Write(codebuf+i,M8BL_PAGESIZE);
		if(m_Port.Read(&c,1,10000))
		{
			AfxMessageBox("ͨŴ!");
			break;
		}
		else
		{
			pProgCtrl->SetPos((80*i)/M8BL_FLASHSIZE);
		}
	}
	
	delete []codebuf;
}

//ⵥƬBOOT
BOOL CTHThread::ScanM8BL()
{
	UCHAR c=M8BL_UARTACK;
	m_Port.Write(&c,1);

	if(m_Port.Read(&c,1,10000))
		return FALSE;
	if(c!=M8BL_UARTACK)
		return FALSE;
	
	return TRUE;
}

//УFLASH
BOOL CTHThread::ReadFlash()
{
	int i,size;
	BOOL Ret=TRUE;
	UCHAR c;
	UCHAR *pagebuf;

	CProgressCtrl *pProgCtrl=(CProgressCtrl *)(m_pParentWnd->GetDlgItem(IDC_PROG));

	m_Port.ClearBuffer();//ڻ
	if(!ScanM8BL())
	{
		AfxMessageBox("δ");
		return FALSE;
	}

	//Ҫҳ
	size=m_CodeSize/M8BL_PAGESIZE;
	if((m_CodeSize%M8BL_PAGESIZE)>0)
		size++;
	size*=M8BL_PAGESIZE;
	
	pagebuf=new UCHAR[M8BL_PAGESIZE];
	if(pagebuf==NULL)
	{
		AfxMessageBox("ڴ治");
		return FALSE;
	}

	//λҳַΪ0
	c=M8BL_SETPAGE;
	m_Port.Write(&c,1);
	c=0;
	m_Port.Write(&c,1);
	m_Port.Read(&c,1,10000);

	for(i=0;i<size;i+=M8BL_PAGESIZE)
	{
		c=M8BL_READ;
		m_Port.Write(&c,1);
		if(m_Port.Read(pagebuf,M8BL_PAGESIZE,10000))
		{
			Ret=FALSE;
			break;
		}

		for(int j=0;j<M8BL_PAGESIZE;j++)
		{
			if((i+j)<m_CodeSize)
			{
				if(pagebuf[j]!=m_pBuffer[i+j])
					Ret=FALSE;
			}
			if(!Ret)
				break;
		}

		pProgCtrl->SetPos((80*i)/M8BL_FLASHSIZE);
		if(!Ret)
			break;
	}

	delete []pagebuf;

	return Ret;

}
