/*
	ļmaster.c 
	Mega8TWIͨʵģʽƬ
	
	ڲ4MHz

	о 2004-09-02   ---------- 2004-09-03
*/


#include <avr/io.h>
#include <avr/delay.h>

#include <avr/twi.h>

#define uint unsigned int
#define uchar unsigned char
#define WAITPRINTDEBUG DelayMs(100)  //ΪģʽƬӡϢʱ


#define KEY	0X04

#define FREQ 4
#define TWI_ADDRESS 0X32

void DelayMs(uint ms)
{
	uint i;
	for(i=0;i<ms;i++)
		_delay_loop_2(FREQ *250);
}

/*************ģʽTWI*************ʼ**************/

//ֹͣ
void twi_stop(void)
{
	TWCR = _BV(TWINT) | _BV(TWSTO) | _BV(TWEN);
}
//𶯿ʼ
void twi_start(void)
{
	uchar trycount=0;

	TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN); 
	while ((TWCR & _BV(TWINT)) == 0) ;

	return TW_STATUS;
}

//дһֽ
void twi_writebyte(uchar c)
{
	TWDR = c;
	TWCR = _BV(TWINT) | _BV(TWEN); 	
	while ((TWCR & _BV(TWINT)) == 0);
	return TW_STATUS;
}

//һֽ ack: trueʱACKfalseʱNACK
uchar twi_readbyte(uchar *c ,uchar ack)
{
	uchar tmp=_BV(TWINT)|_BV(TWEN);
		
	if(ack)
		tmp|=_BV(TWEA); 	
	TWCR=tmp;
	while ((TWCR & _BV(TWINT)) == 0) ;

	*c=TWDR;

	return TW_STATUS;
}
/*************ģʽIIC***************************/

//ⰴ
uchar WaitKeyDown(void)
{
	uchar key;
	
	while(1)
	{
		key=PIND & KEY;
		if(	key!=KEY)
		{
			DelayMs(30);
			key=PIND & KEY;
			if(key!=KEY)
				break;
		}
		DelayMs(1);
	}

	while((PIND & KEY)!=KEY)
		DelayMs(10);
		
	return key;
}

int main(void)
{
	uchar i;
	
	//ʹSCLSDAڲ
	DDRC=0;
	PORTC=0X30;
	
	//
	DDRD=0;
	PORTD=0;
	
	TWBR=73;//
	
	while(1)
	{
		WaitKeyDown();
	
		twi_start();
		WAITPRINTDEBUG;
		twi_writebyte(TWI_ADDRESS|TW_WRITE);
		WAITPRINTDEBUG;
		for(i=0;i<10;i++)
		{
			twi_writebyte(i);
			WAITPRINTDEBUG;
		}
		twi_stop();
	}
}
